<?xml version="1.0" encoding="UTF-8"?>
<grammar datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes" xmlns="http://relaxng.org/ns/structure/1.0" xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns:number="http://openoffice.org/2000/datastyle" xmlns:form="http://openoffice.org/2000/form" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:dr3d="http://openoffice.org/2000/dr3d" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:office="http://openoffice.org/2000/office" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:draw="http://openoffice.org/2000/drawing" xmlns:meta="http://openoffice.org/2000/meta" xmlns:text="http://openoffice.org/2000/text" xmlns:chart="http://openoffice.org/2000/chart" xmlns:svg="http://www.w3.org/2000/svg" xmlns:style="http://openoffice.org/2000/style" xmlns:table="http://openoffice.org/2000/table" xmlns:presentation="http://openoffice.org/2001/presentation" xmlns:config="http://openoffice.org/2001/config" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:script="http://openoffice.org/2000/script">
<!--
	$Id: drawing.mod,v 1.82 2002/10/21 16:44:56 cl Exp $

   The Contents of this file are made available subject to the terms of
   either of the following licenses

          - GNU Lesser General Public License Version 2.1
          - Sun Industry Standards Source License Version 1.1

   Sun Microsystems Inc., October, 2000

   GNU Lesser General Public License Version 2.1
   =============================================
   Copyright 2000 by Sun Microsystems, Inc.
   901 San Antonio Road, Palo Alto, CA 94303, USA

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License version 2.1, as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA  02111-1307  USA


   Sun Industry Standards Source License Version 1.1
   =================================================
   The contents of this file are subject to the Sun Industry Standards
   Source License Version 1.1 (the "License"); You may not use this file
   except in compliance with the License. You may obtain a copy of the
   License at http://www.openoffice.org/license.html.

   Software provided under this License is provided on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
   See the License for the specific provisions governing your rights and
   obligations concerning the Software.

   The Initial Developer of the Original Code is: Sun Microsystems, Inc.

   Copyright: 2000 by Sun Microsystems, Inc.

   All Rights Reserved.

   Contributor(s): _______________________________________

-->
  <define name="points">
    <data type="string"/>
  </define>
  <define name="pathData">
    <data type="string"/>
  </define>
  <define name="gradient-style">
    <choice>
      <value>linear</value>
      <value>axial</value>
      <value>radial</value>
      <value>ellipsoid</value>
      <value>square</value>
      <value>rectangular</value>
    </choice>
  </define>
  <define name="draw-position">
    <optional>
      <attribute name="svg:x">
        <ref name="coordinate"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="svg:y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw-end-position">
    <optional>
      <attribute name="table:end-cell-address">
        <ref name="cell-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-x">
        <ref name="coordinate"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw-size">
    <optional>
      <attribute name="svg:width">
        <ref name="coordinate"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="svg:height">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw-transform">
    <optional>
      <attribute name="draw:transform"/>
    </optional>
  </define>
  <define name="draw-viewbox">
    <attribute name="svg:viewBox"/>
  </define>
  <define name="draw-style-name">
    <optional>
      <attribute name="draw:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="presentation:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="draw:text-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw-text">
    <zeroOrMore>
      <choice>
        <ref name="text.p"/>
        <ref name="text.unordered-list"/>
        <ref name="text.ordered-list"/>
      </choice>
    </zeroOrMore>
  </define>
  <define name="zindex">
    <optional>
      <attribute name="draw:z-index">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="distance">
    <data type="string"/>
  </define>
  <define name="rectanglePoint">
    <choice>
      <value>top-left</value>
      <value>top</value>
      <value>top-right</value>
      <value>left</value>
      <value>center</value>
      <value>right</value>
      <value>bottom-left</value>
      <value>bottom</value>
      <value>bottom-right</value>
    </choice>
  </define>
  <define name="vector3D">
    <data type="string"/>
  </define>
  <define name="text-anchor">
    <optional>
      <attribute name="text:anchor-type">
        <ref name="anchorType"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="text:anchor-page-number">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="layerName">
    <data type="string"/>
  </define>
  <define name="table-background">
    <optional>
      <attribute name="table:table-background">
        <choice>
          <value>true</value>
          <value>false</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- commont presentation shape attributes -->
  <define name="presentation-classes">
    <choice>
      <value>title</value>
      <value>outline</value>
      <value>subtitle</value>
      <value>text</value>
      <value>graphic</value>
      <value>object</value>
      <value>chart</value>
      <value>table</value>
      <value>orgchart</value>
      <value>page</value>
      <value>notes</value>
    </choice>
  </define>
<!-- ENTITY % presentation-class "presentation:class %presentation-classes; #IMPLIED" -->
  <define name="presentation-class">
    <optional>
      <attribute name="presentation:class">
        <ref name="presentation-classes"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="presentation:placeholder">
        <choice>
          <value>true</value>
          <value>false</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="presentation:user-transformed">
        <choice>
          <value>true</value>
          <value>false</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentationEffects">
    <choice>
      <value>none</value>
      <value>fade</value>
      <value>move</value>
      <value>stripes</value>
      <value>open</value>
      <value>close</value>
      <value>dissolve</value>
      <value>wavyline</value>
      <value>random</value>
      <value>lines</value>
      <value>laser</value>
      <value>appear</value>
      <value>hide</value>
      <value>move-short</value>
      <value>checkerboard</value>
      <value>rotate</value>
      <value>stretch</value>
    </choice>
  </define>
  <define name="presentationEffectDirections">
    <choice>
      <value>none</value>
      <value>from-left</value>
      <value>from-top</value>
      <value>from-right</value>
      <value>from-bottom</value>
      <value>from-center</value>
      <value>from-upper-left</value>
      <value>from-upper-right</value>
      <value>from-lower-left</value>
      <value>from-lower-right</value>
      <value>to-left</value>
      <value>to-top</value>
      <value>to-right</value>
      <value>to-bottom</value>
      <value>to-upper-left</value>
      <value>to-upper-right</value>
      <value>to-lower-right</value>
      <value>to-lower-left</value>
      <value>path</value>
      <value>spiral-inward-left</value>
      <value>spiral-inward-right</value>
      <value>spiral-outward-left</value>
      <value>spiral-outward-right</value>
      <value>vertical</value>
      <value>horizontal</value>
      <value>to-center</value>
      <value>clockwise</value>
      <value>counter-clockwise</value>
    </choice>
  </define>
  <define name="presentationSpeeds">
    <choice>
      <value>slow</value>
      <value>medium</value>
      <value>fast</value>
    </choice>
  </define>
<!-- Drawing shapes -->
  <define name="draw.rect">
    <element name="draw:rect">
      <ref name="draw.rect-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.rect"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <optional>
      <attribute name="draw:corner-radius">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.rect-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.line">
    <element name="draw:line">
      <ref name="draw.line-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.line"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <optional>
      <attribute name="svg:x1">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <optional>
      <attribute name="svg:y1">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <attribute name="svg:x2">
      <ref name="length"/>
    </attribute>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <attribute name="svg:y2">
      <ref name="length"/>
    </attribute>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <optional>
      <attribute name="svg:y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.line-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.polyline">
    <element name="draw:polyline">
      <ref name="draw.polyline-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.polyline"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <attribute name="draw:points">
      <ref name="points"/>
    </attribute>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.polyline-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.polygon">
    <element name="draw:polygon">
      <ref name="draw.polygon-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.polygon"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <attribute name="draw:points">
      <ref name="points"/>
    </attribute>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.polygon-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.path">
    <element name="draw:path">
      <ref name="draw.path-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.path"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <attribute name="svg:d">
      <ref name="pathData"/>
    </attribute>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.path-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.circle">
    <element name="draw:circle">
      <ref name="draw.circle-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.circle"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:kind" a:defaultValue="full">
        <choice>
          <value>full</value>
          <value>section</value>
          <value>cut</value>
          <value>arc</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.ellipse">
    <element name="draw:ellipse">
      <ref name="draw.ellipse-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.ellipse"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <optional>
      <attribute name="draw:kind" a:defaultValue="full">
        <choice>
          <value>full</value>
          <value>section</value>
          <value>cut</value>
          <value>arc</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.ellipse-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.connector">
    <element name="draw:connector">
      <ref name="draw.connector-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.connector"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:type" a:defaultValue="standard">
        <choice>
          <value>standard</value>
          <value>lines</value>
          <value>line</value>
          <value>curve</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:line-skew"/>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <attribute name="svg:x1">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <attribute name="svg:y1">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <attribute name="svg:x2">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <attribute name="svg:y2">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-shape"/>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-glue-point">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-shape"/>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-glue-point">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.connector-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.control">
    <element name="draw:control">
      <ref name="draw.control-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.control"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="control-id"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.control-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.g">
    <element name="draw:g">
      <ref name="draw.g-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <zeroOrMore>
        <ref name="shapes"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.g"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <optional>
      <attribute name="svg:y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.g-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-thumbnail">
    <element name="draw:page-thumbnail">
      <ref name="draw.page-thumbnail-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.page-thumbnail"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="draw:page-number">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="presentation-class"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.page-thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.caption">
    <element name="draw:caption">
      <ref name="draw.caption-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.caption"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="draw-size"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-point-x">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-point-y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.caption-attlist" combine="interleave">
    <optional>
      <attribute name="draw:corner-radius">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.measure">
    <element name="draw:measure">
      <ref name="draw.measure-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <ref name="draw-text"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.measure"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <attribute name="svg:x1">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <attribute name="svg:y1">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <attribute name="svg:x2">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <attribute name="svg:y2">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.measure-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
<!-- graphic style elements -->
  <define name="draw.gradient">
    <element name="draw:gradient">
      <ref name="draw.gradient-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.gradient"/>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <attribute name="draw:style">
      <ref name="gradient-style"/>
    </attribute>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:cx">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:cy">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-intensity">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-intensity">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:angle">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.gradient-attlist" combine="interleave">
    <optional>
      <attribute name="draw:border">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.hatch">
    <element name="draw:hatch">
      <ref name="draw.hatch-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.hatch"/>
  </define>
  <define name="draw.hatch-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.hatch-attlist" combine="interleave">
    <attribute name="draw:style">
      <choice>
        <value>single</value>
        <value>double</value>
        <value>triple</value>
      </choice>
    </attribute>
  </define>
  <define name="draw.hatch-attlist" combine="interleave">
    <optional>
      <attribute name="draw:color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.hatch-attlist" combine="interleave">
    <optional>
      <attribute name="draw:distance">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.hatch-attlist" combine="interleave">
    <optional>
      <attribute name="draw:rotation">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.fill-image">
    <element name="draw:fill-image">
      <ref name="draw.fill-image-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.fill-image"/>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.fill-image-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency">
    <element name="draw:transparency">
      <ref name="draw.transparency-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.transparency"/>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <attribute name="draw:style">
      <ref name="gradient-style"/>
    </attribute>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:cx">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:cy">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:angle">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.transparency-attlist" combine="interleave">
    <optional>
      <attribute name="draw:border">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.marker">
    <element name="draw:marker">
      <ref name="draw.marker-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.marker"/>
  </define>
  <define name="draw.marker-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.marker-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.marker-attlist" combine="interleave">
    <attribute name="svg:d">
      <ref name="pathData"/>
    </attribute>
  </define>
  <define name="draw.stroke-dash">
    <element name="draw:stroke-dash">
      <ref name="draw.stroke-dash-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.stroke-dash"/>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:style">
        <choice>
          <value>rect</value>
          <value>round</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:dots1">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:dots1-length">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:dots2">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:dots2-length">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.stroke-dash-attlist" combine="interleave">
    <optional>
      <attribute name="draw:distance">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
<!-- stroke attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:stroke">
        <choice>
          <value>none</value>
          <value>dash</value>
          <value>solid</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:stroke-dash"/>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="svg:stroke-width">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="svg:stroke-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-start">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-end">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-start-width">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-end-width">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-start-center">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:marker-end-center">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="svg:stroke-opacity">
        <ref name="floatOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="svg:stroke-linejoin">
        <choice>
          <value>miter</value>
          <value>round</value>
          <value>bevel</value>
          <value>middle</value>
          <value>none</value>
          <value>inherit</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- text attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:auto-grow-width">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:auto-grow-height">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fit-to-size">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fit-to-contour">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:textarea-horizontal-align">
        <choice>
          <value>left</value>
          <value>center</value>
          <value>right</value>
          <value>justify</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:textarea-vertical-align">
        <choice>
          <value>top</value>
          <value>middle</value>
          <value>bottom</value>
          <value>justify</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:writing-mode" a:defaultValue="lr-tb">
        <choice>
          <value>lr-tb</value>
          <value>tb-rl</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- fill attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill">
        <choice>
          <value>none</value>
          <value>solid</value>
          <value>bitmap</value>
          <value>gradient</value>
          <value>hatch</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-gradient-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:gradient-step-count"/>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-hatch-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-hatch-solid">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="style:repeat">
        <choice>
          <value>no-repeat</value>
          <value>repeat</value>
          <value>stretch</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-ref-point-x">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-ref-point-y">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fill-image-ref-point">
        <ref name="rectanglePoint"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:tile-repeat-offset"/>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:transparency">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:transparency-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
<!-- graphic attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:color-mode">
        <choice>
          <value>greyscale</value>
          <value>mono</value>
          <value>watermark</value>
          <value>standard</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:luminance">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:contrast">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:gamma">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:red">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:green">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:blue">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:color-inversion">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:mirror">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- shadow attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:shadow">
        <choice>
          <value>visible</value>
          <value>hidden</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:shadow-offset-x">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:shadow-offset-y">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:shadow-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:shadow-transparency"/>
    </optional>
  </define>
<!-- connector attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-line-spacing-horizontal">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-line-spacing-vertical">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-line-spacing-horizontal">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-line-spacing-vertical">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
<!-- measure attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:line-distance">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:guide-overhang">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:guide-distance">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:start-guide">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:end-guide">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:measure-align">
        <choice>
          <value>automatic</value>
          <value>left-outside</value>
          <value>inside</value>
          <value>right-outside</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:measure-vertical-align">
        <choice>
          <value>automatic</value>
          <value>above</value>
          <value>below</value>
          <value>center</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:unit">
        <choice>
          <value>automatic</value>
          <value>mm</value>
          <value>cm</value>
          <value>m</value>
          <value>km</value>
          <value>pt</value>
          <value>pc</value>
          <value>inch</value>
          <value>ft</value>
          <value>mi</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:show-unit">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:placing">
        <choice>
          <value>below</value>
          <value>above</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:parallel">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:decimal-places">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
<!-- frame attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:frame-display-scrollbar">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:frame-display-border">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:frame-margin-horizontal">
        <ref name="nonNegativePixelLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:frame-margin-vertical">
        <ref name="nonNegativePixelLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:size-protect">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:move-protect">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- ole object attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:visible-area-left">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:visible-area-top">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:visible-area-width">
        <ref name="positiveLength"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:visible-area-height">
        <ref name="positiveLength"/>
      </attribute>
    </optional>
  </define>
<!-- fontwork attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-style">
        <choice>
          <value>rotate</value>
          <value>upright</value>
          <value>slant-x</value>
          <value>slant-y</value>
          <value>none</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-adjust">
        <choice>
          <value>left</value>
          <value>right</value>
          <value>autosize</value>
          <value>center</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-distance">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-start">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-mirror">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-outline">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-shadow">
        <choice>
          <value>normal</value>
          <value>slant</value>
          <value>none</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-shadow-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-shadow-offset-x">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-shadow-offset-y">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-form">
        <choice>
          <value>none</value>
          <value>top-circle</value>
          <value>bottom-circle</value>
          <value>left-circle</value>
          <value>right-circle</value>
          <value>top-arc</value>
          <value>bottom-arc</value>
          <value>left-arc</value>
          <value>right-arc</value>
          <value>button1</value>
          <value>button2</value>
          <value>button3</value>
          <value>button4</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-hide-form">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:fontwork-shadow-transparence">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
<!-- caption attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-type">
        <choice>
          <value>straight-line</value>
          <value>angled-line</value>
          <value>angled-connector-line</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-angle-type">
        <choice>
          <value>fixed</value>
          <value>free</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-gap">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-escape-direction">
        <choice>
          <value>horizontal</value>
          <value>vertical</value>
          <value>auto</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-escape">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-line-length">
        <ref name="distance"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:caption-fit-line-length">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- Animations -->
  <define name="presentation.sound">
    <element name="presentation:sound">
      <ref name="presentation.sound-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.sound"/>
  </define>
  <define name="presentation.sound-attlist" combine="interleave">
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
  </define>
  <define name="presentation.sound-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="presentation.sound-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.sound-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate" a:defaultValue="onRequest">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.sound-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:play-full">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-shape">
    <element name="presentation:show-shape">
      <ref name="presentation.show-shape-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.show-shape"/>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:effect" a:defaultValue="none">
        <ref name="presentationEffects"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:direction" a:defaultValue="none">
        <ref name="presentationEffectDirections"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-scale" a:defaultValue="100%">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:path-id"/>
    </optional>
  </define>
  <define name="presentation.show-text">
    <element name="presentation:show-text">
      <ref name="presentation.show-text-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.show-text"/>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:effect" a:defaultValue="none">
        <ref name="presentationEffects"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:direction" a:defaultValue="none">
        <ref name="presentationEffectDirections"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-scale" a:defaultValue="100%">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.show-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:path-id"/>
    </optional>
  </define>
  <define name="presentation.hide-shape">
    <element name="presentation:hide-shape">
      <ref name="presentation.hide-shape-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.hide-shape"/>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:effect" a:defaultValue="none">
        <ref name="presentationEffects"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:direction" a:defaultValue="none">
        <ref name="presentationEffectDirections"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-scale" a:defaultValue="100%">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-shape-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:path-id"/>
    </optional>
  </define>
  <define name="presentation.hide-text">
    <element name="presentation:hide-text">
      <ref name="presentation.hide-text-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.hide-text"/>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:effect" a:defaultValue="none">
        <ref name="presentationEffects"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:direction" a:defaultValue="none">
        <ref name="presentationEffectDirections"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-scale" a:defaultValue="100%">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.hide-text-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:path-id"/>
    </optional>
  </define>
  <define name="presentation.dim">
    <element name="presentation:dim">
      <ref name="presentation.dim-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.dim"/>
  </define>
  <define name="presentation.dim-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.dim-attlist" combine="interleave">
    <attribute name="draw:color">
      <ref name="color"/>
    </attribute>
  </define>
  <define name="presentation.play">
    <element name="presentation:play">
      <ref name="presentation.play-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.play"/>
  </define>
  <define name="presentation.play-attlist" combine="interleave">
    <attribute name="draw:shape-id"/>
  </define>
  <define name="presentation.play-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.animations">
    <element name="presentation:animations">
      <ref name="presentation.animations-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="presentation.show-shape"/>
          <ref name="presentation.show-text"/>
          <ref name="presentation.hide-shape"/>
          <ref name="presentation.hide-text"/>
          <ref name="presentation.dim"/>
          <ref name="presentation.play"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="presentation.animations-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.animations"/>
  </define>
  <define name="presentation.show">
    <element name="presentation:show">
      <ref name="presentation.show-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.show"/>
  </define>
  <define name="presentation.show-attlist" combine="interleave">
    <attribute name="presentation:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="presentation.show-attlist" combine="interleave">
    <attribute name="presentation:pages"/>
  </define>
  <define name="presentation.settings">
    <element name="presentation:settings">
      <ref name="presentation.settings-attlist"/>
      <zeroOrMore>
        <ref name="presentation.show"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.settings"/>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-page">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:show">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:full-screen" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:endless" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:pause">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:show-logo" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:force-manual" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:mouse-visible" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:mouse-as-pen" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-with-navigator" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:animations" a:defaultValue="enabled">
        <choice>
          <value>enabled</value>
          <value>disabled</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:stay-on-top" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.settings-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:transition-on-click" a:defaultValue="enabled">
        <choice>
          <value>enabled</value>
          <value>disabled</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- Drawing page -->
  <define name="draw.page">
    <element name="draw:page">
      <ref name="draw.page-attlist"/>
      <optional>
        <ref name="office.forms"/>
      </optional>
      <zeroOrMore>
        <ref name="shapes"/>
      </zeroOrMore>
      <optional>
        <ref name="presentation.animations"/>
      </optional>
      <optional>
        <ref name="presentation.notes"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.page"/>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="draw:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <attribute name="draw:master-page-name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:presentation-page-layout-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.page-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
  </define>
<!-- Presentation notes -->
  <define name="presentation.notes">
    <element name="presentation:notes">
      <ref name="presentation.notes-attlist"/>
      <zeroOrMore>
        <ref name="shapes"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.notes"/>
  </define>
  <define name="presentation.notes-attlist" combine="interleave">
    <optional>
      <attribute name="style:page-master-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
<!-- presentation page layouts -->
  <define name="style.presentation-page-layout">
    <element name="style:presentation-page-layout">
      <ref name="style.presentation-page-layout-attlist"/>
      <zeroOrMore>
        <ref name="presentation.placeholder"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="style.presentation-page-layout"/>
  </define>
  <define name="style.presentation-page-layout-attlist" combine="interleave">
    <attribute name="style:name">
      <ref name="styleName"/>
    </attribute>
  </define>
  <define name="presentation.placeholder">
    <element name="presentation:placeholder">
      <ref name="presentation.placeholder-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.placeholder"/>
  </define>
  <define name="presentation.placeholder-attlist" combine="interleave">
    <attribute name="presentation:object">
      <choice>
        <value>title</value>
        <value>outline</value>
        <value>subtitle</value>
        <value>text</value>
        <value>graphic</value>
        <value>object</value>
        <value>chart</value>
        <value>orgchart</value>
        <value>page</value>
        <value>notes</value>
        <value>handout</value>
      </choice>
    </attribute>
  </define>
  <define name="presentation.placeholder-attlist" combine="interleave">
    <attribute name="svg:x">
      <ref name="coordinateOrPercentage"/>
    </attribute>
  </define>
  <define name="presentation.placeholder-attlist" combine="interleave">
    <attribute name="svg:y">
      <ref name="coordinateOrPercentage"/>
    </attribute>
  </define>
  <define name="presentation.placeholder-attlist" combine="interleave">
    <attribute name="svg:width">
      <ref name="lengthOrPercentage"/>
    </attribute>
  </define>
  <define name="presentation.placeholder-attlist" combine="interleave">
    <attribute name="svg:height">
      <ref name="lengthOrPercentage"/>
    </attribute>
  </define>
<!-- presentation page attributes -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:transition-type">
        <choice>
          <value>manual</value>
          <value>automatic</value>
          <value>semi-automatic</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:transition-style">
        <choice>
          <value>none</value>
          <value>fade-from-left</value>
          <value>fade-from-top</value>
          <value>fade-from-right</value>
          <value>fade-from-bottom</value>
          <value>fade-to-center</value>
          <value>fade-from-center</value>
          <value>move-from-left</value>
          <value>move-from-top</value>
          <value>move-from-right</value>
          <value>move-from-bottom</value>
          <value>roll-from-top</value>
          <value>roll-from-left</value>
          <value>roll-from-right</value>
          <value>roll-from-bottom</value>
          <value>vertical-stripes</value>
          <value>horizontal-stripes</value>
          <value>clockwise</value>
          <value>counterclockwise</value>
          <value>fade-from-upperleft</value>
          <value>fade-from-upperright</value>
          <value>fade-from-lowerleft</value>
          <value>fade-from-lowerright</value>
          <value>close-vertical</value>
          <value>close-horizontal</value>
          <value>open-vertical</value>
          <value>open-horizontal</value>
          <value>spiralin-left</value>
          <value>spiralin-right</value>
          <value>spiralout-left</value>
          <value>spiralout-right</value>
          <value>dissolve</value>
          <value>wavyline-from-left</value>
          <value>wavyline-from-top</value>
          <value>wavyline-from-right</value>
          <value>wavyline-from-bottom</value>
          <value>random</value>
          <value>stretch-from-left</value>
          <value>stretch-from-top</value>
          <value>stretch-from-right</value>
          <value>stretch-from-bottom</value>
          <value>vertical-lines</value>
          <value>horizontal-lines</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:transition-speed">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:duration">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:visibility">
        <choice>
          <value>visible</value>
          <value>hidden</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="draw:background-size">
        <choice>
          <value>full</value>
          <value>border</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:background-objects-visible">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:background-visible">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- text boxes -->
  <define name="draw.text-box">
    <element name="draw:text-box">
      <ref name="draw.text-box-attlist"/>
      <optional>
        <ref name="office.events"/>
      </optional>
      <optional>
        <ref name="draw.image-map"/>
      </optional>
      <ref name="sectionText"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.text-box"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="draw:chain-next-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-width">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-height">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="fo:min-height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <ref name="presentation-class"/>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.text-box-attlist" combine="interleave">
    <optional>
      <attribute name="draw:corner-radius">
        <ref name="nonNegativeLength"/>
      </attribute>
    </optional>
  </define>
<!-- image -->
  <define name="draw.image">
    <element name="draw:image">
      <ref name="draw.image-attlist"/>
      <optional>
        <ref name="office.binary-data"/>
      </optional>
      <optional>
        <ref name="office.events"/>
      </optional>
      <optional>
        <ref name="draw.image-map"/>
      </optional>
      <optional>
        <ref name="svg.desc"/>
      </optional>
      <optional>
        <choice>
          <ref name="draw.contour-polygon"/>
          <ref name="draw.contour-path"/>
        </choice>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.image"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="draw-transform"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="draw:filter-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="presentation-class"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-width">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.image-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-height">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
<!-- objects -->
  <define name="draw.thumbnail">
    <element name="draw:thumbnail">
      <ref name="draw.thumbnail-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.thumbnail"/>
  </define>
  <define name="draw.thumbnail-attlist" combine="interleave">
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
  </define>
  <define name="draw.thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.thumbnail-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="math.math">
    <element name="math:math">
      <ref name="math.math-attlist"/>
      <zeroOrMore>
        <ref name="any"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="math.math-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="math.math"/>
  </define>
<!-- dummy (we have no MathML DTD currently)-->
  <define name="draw.object">
    <element name="draw:object">
      <ref name="draw.object-attlist"/>
      <optional>
        <ref name="draw.thumbnail"/>
      </optional>
      <optional>
        <choice>
          <ref name="office.document"/>
          <ref name="math.math"/>
        </choice>
      </optional>
      <optional>
        <ref name="office.events"/>
      </optional>
      <optional>
        <ref name="draw.image-map"/>
      </optional>
      <optional>
        <ref name="svg.desc"/>
      </optional>
      <optional>
        <choice>
          <ref name="draw.contour-polygon"/>
          <ref name="draw.contour-path"/>
        </choice>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.object"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="presentation-class"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="draw:notify-on-update-of-ranges">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-width">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-height">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole">
    <element name="draw:object-ole">
      <ref name="draw.object-ole-attlist"/>
      <choice>
        <optional>
          <ref name="office.binary-data"/>
        </optional>
        <optional>
          <ref name="office.events"/>
        </optional>
        <optional>
          <ref name="draw.image-map"/>
        </optional>
        <optional>
          <ref name="svg.desc"/>
        </optional>
        <optional>
          <ref name="draw.contour-polygon"/>
        </optional>
        <optional>
          <ref name="draw.contour-path"/>
        </optional>
        <optional>
          <ref name="draw.thumbnail"/>
        </optional>
      </choice>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.object-ole"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="draw:class-id"/>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="text-anchor"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="presentation-class"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-width">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.object-ole-attlist" combine="interleave">
    <optional>
      <attribute name="style:rel-height">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="svg.desc">
    <element name="svg:desc">
      <ref name="svg.desc-attlist"/>
      <text/>
    </element>
  </define>
  <define name="svg.desc-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="svg.desc"/>
  </define>
  <define name="draw.contour-polygon">
    <element name="draw:contour-polygon">
      <ref name="draw.contour-polygon-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.contour-polygon"/>
  </define>
  <define name="draw.contour-polygon-attlist" combine="interleave">
    <attribute name="svg:width">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.contour-polygon-attlist" combine="interleave">
    <attribute name="svg:height">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.contour-polygon-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.contour-polygon-attlist" combine="interleave">
    <attribute name="draw:points">
      <ref name="points"/>
    </attribute>
  </define>
  <define name="draw.contour-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="draw:recreate-on-edit">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.contour-path">
    <element name="draw:contour-path">
      <ref name="draw.contour-path-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.contour-path"/>
  </define>
  <define name="draw.contour-path-attlist" combine="interleave">
    <attribute name="svg:width">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.contour-path-attlist" combine="interleave">
    <attribute name="svg:height">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.contour-path-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="draw.contour-path-attlist" combine="interleave">
    <attribute name="svg:d">
      <ref name="pathData"/>
    </attribute>
  </define>
  <define name="draw.contour-path-attlist" combine="interleave">
    <optional>
      <attribute name="draw:recreate-on-edit">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- hyperlink -->
  <define name="draw.a">
    <element name="draw:a">
      <ref name="draw.a-attlist"/>
      <choice>
        <ref name="draw.image"/>
        <ref name="draw.text-box"/>
      </choice>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.a"/>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate" a:defaultValue="onRequest">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="office:name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="office:target-frame-name">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.a-attlist" combine="interleave">
    <optional>
      <attribute name="office:server-map" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
<!-- 3d properties -->
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:horizontal-segments">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:vertical-segments">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:edge-rounding">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:edge-rounding-mode">
        <choice>
          <value>correct</value>
          <value>attractive</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:back-scale">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:end-angle">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:depth">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:backface-culling">
        <choice>
          <value>enabled</value>
          <value>disabled</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:lighting-mode">
        <choice>
          <value>standard</value>
          <value>double-sided</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:normals-kind">
        <choice>
          <value>object</value>
          <value>flat</value>
          <value>sphere</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:normals-direction">
        <choice>
          <value>normal</value>
          <value>inverse</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:texture-generation-mode-x">
        <choice>
          <value>object</value>
          <value>parallel</value>
          <value>sphere</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:texture-generation-mode-y">
        <choice>
          <value>object</value>
          <value>parallel</value>
          <value>sphere</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:texture-kind">
        <choice>
          <value>luminance</value>
          <value>intesity</value>
          <value>color</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:texture-filter">
        <choice>
          <value>enabled</value>
          <value>disabled</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:texture-mode">
        <choice>
          <value>replace</value>
          <value>modulate</value>
          <value>blend</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:ambient-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:emissive-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:specular-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:diffuse-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:shininess">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="style.properties-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:shadow">
        <choice>
          <value>visible</value>
          <value>hidden</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.light">
    <element name="dr3d:light">
      <ref name="dr3d.light-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.light"/>
  </define>
  <define name="dr3d.light-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:diffuse-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.light-attlist" combine="interleave">
    <attribute name="dr3d:direction">
      <ref name="vector3D"/>
    </attribute>
  </define>
  <define name="dr3d.light-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:enabled">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.light-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:specular">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="shapes3d">
    <choice>
      <ref name="dr3d.scene"/>
      <ref name="dr3d.extrude"/>
      <ref name="dr3d.sphere"/>
      <ref name="dr3d.rotate"/>
      <ref name="dr3d.cube"/>
    </choice>
  </define>
  <define name="dr3d.cube">
    <element name="dr3d:cube">
      <ref name="dr3d.cube-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.cube"/>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:transform"/>
    </optional>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:min-edge">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:max-edge">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="dr3d.cube-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.sphere">
    <element name="dr3d:sphere">
      <ref name="dr3d.sphere-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.sphere"/>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:transform"/>
    </optional>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:center">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:size">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="dr3d.sphere-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.extrude">
    <element name="dr3d:extrude">
      <ref name="dr3d.extrude-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.extrude"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:transform"/>
    </optional>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <attribute name="svg:d">
      <ref name="pathData"/>
    </attribute>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="dr3d.extrude-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.rotate">
    <element name="dr3d:rotate">
      <ref name="dr3d.rotate-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.rotate"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:transform"/>
    </optional>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <ref name="draw-viewbox"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <attribute name="svg:d">
      <ref name="pathData"/>
    </attribute>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="dr3d.rotate-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene">
    <element name="dr3d:scene">
      <ref name="dr3d.scene-attlist"/>
      <zeroOrMore>
        <ref name="dr3d.light"/>
      </zeroOrMore>
      <zeroOrMore>
        <ref name="shapes3d"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="dr3d.scene"/>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="svg:x">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="svg:y">
        <ref name="coordinate"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:vrp">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:vpn">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:vup">
        <ref name="vector3D"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:projection">
        <choice>
          <value>parallel</value>
          <value>perspective</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:transform"/>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:distance">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:focal-length">
        <ref name="length"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:shadow-slant">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:shade-mode">
        <choice>
          <value>flat</value>
          <value>phong</value>
          <value>gouraud</value>
          <value>draft</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:ambient-color">
        <ref name="color"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="dr3d:lighting-mode">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <optional>
      <attribute name="draw:id"/>
    </optional>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
  <define name="dr3d.scene-attlist" combine="interleave">
    <ref name="table-background"/>
  </define>
<!-- layer -->
  <define name="draw.layer-set">
    <element name="draw:layer-set">
      <ref name="draw.layer-set-attlist"/>
      <zeroOrMore>
        <ref name="draw.layer"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="draw.layer-set-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.layer-set"/>
  </define>
  <define name="draw.layer">
    <element name="draw:layer">
      <ref name="draw.layer-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.layer"/>
  </define>
  <define name="draw.layer-attlist" combine="interleave">
    <attribute name="draw:name">
      <ref name="layerName"/>
    </attribute>
  </define>
<!-- events -->
  <define name="presentation.event">
    <element name="presentation:event">
      <ref name="presentation.event-attlist"/>
      <optional>
        <ref name="presentation.sound"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="presentation.event"/>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <ref name="event-name"/>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <attribute name="presentation:action">
      <choice>
        <value>none</value>
        <value>previous-page</value>
        <value>next-page</value>
        <value>first-page</value>
        <value>last-page</value>
        <value>hide</value>
        <value>stop</value>
        <value>execute</value>
        <value>show</value>
        <value>verb</value>
        <value>fade-out</value>
        <value>sound</value>
      </choice>
    </attribute>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:effect" a:defaultValue="none">
        <ref name="presentationEffects"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:direction" a:defaultValue="none">
        <ref name="presentationEffectDirections"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:speed" a:defaultValue="medium">
        <ref name="presentationSpeeds"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:start-scale" a:defaultValue="100%">
        <ref name="percentage"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="presentation.event-attlist" combine="interleave">
    <optional>
      <attribute name="presentation:verb">
        <ref name="nonNegativeInteger"/>
      </attribute>
    </optional>
  </define>
<!-- applets -->
  <define name="draw.applet">
    <element name="draw:applet">
      <ref name="draw.applet-attlist"/>
      <optional>
        <ref name="draw.thumbnail"/>
      </optional>
      <zeroOrMore>
        <ref name="draw.param"/>
      </zeroOrMore>
      <optional>
        <ref name="svg.desc"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.applet"/>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <attribute name="draw:code"/>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="draw:object"/>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="draw:archive"/>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="draw:may-script" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name"/>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.applet-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
<!-- plugins -->
  <define name="draw.plugin">
    <element name="draw:plugin">
      <ref name="draw.plugin-attlist"/>
      <optional>
        <ref name="draw.thumbnail"/>
      </optional>
      <zeroOrMore>
        <ref name="draw.param"/>
      </zeroOrMore>
      <optional>
        <ref name="svg.desc"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.plugin"/>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="draw:mime-type"/>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name"/>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.plugin-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
<!-- Paramaters -->
  <define name="draw.param">
    <element name="draw:param">
      <ref name="draw.param-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.param"/>
  </define>
  <define name="draw.param-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name"/>
    </optional>
  </define>
  <define name="draw.param-attlist" combine="interleave">
    <optional>
      <attribute name="draw:value"/>
    </optional>
  </define>
<!-- Floating Frames -->
  <define name="draw.floating-frame">
    <element name="draw:floating-frame">
      <ref name="draw.floating-frame-attlist"/>
      <optional>
        <ref name="draw.thumbnail"/>
      </optional>
      <optional>
        <ref name="svg.desc"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.floating-frame"/>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>embed</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:actuate">
        <choice>
          <value>onLoad</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="draw:name"/>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="draw:frame-name"/>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <ref name="draw-style-name"/>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="svg:width">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="svg:height">
        <ref name="lengthOrPercentage"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <ref name="zindex"/>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <optional>
      <attribute name="draw:layer">
        <ref name="layerName"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <ref name="draw-position"/>
  </define>
  <define name="draw.floating-frame-attlist" combine="interleave">
    <ref name="draw-end-position"/>
  </define>
<!-- Image Maps -->
  <define name="draw.image-map">
    <element name="draw:image-map">
      <ref name="draw.image-map-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="draw.area-rectangle"/>
          <ref name="draw.area-circle"/>
          <ref name="draw.area-polygon"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="draw.image-map-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.image-map"/>
  </define>
  <define name="draw.area-rectangle">
    <element name="draw:area-rectangle">
      <ref name="draw.area-rectangle-attlist"/>
      <optional>
        <ref name="svg.desc"/>
      </optional>
      <optional>
        <ref name="office.events"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.area-rectangle"/>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="office:target-frame-name"/>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="office:name"/>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:nohref">
        <choice>
          <value>nohref</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <attribute name="svg:x">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <attribute name="svg:y">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <attribute name="svg:width">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-rectangle-attlist" combine="interleave">
    <attribute name="svg:height">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-circle">
    <element name="draw:area-circle">
      <ref name="draw.area-circle-attlist"/>
      <optional>
        <ref name="svg.desc"/>
      </optional>
      <optional>
        <ref name="office.events"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.area-circle"/>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="office:target-frame-name"/>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="office:name"/>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <optional>
      <attribute name="draw:nohref">
        <choice>
          <value>nohref</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <attribute name="svg:cx">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <attribute name="svg:cy">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-circle-attlist" combine="interleave">
    <attribute name="svg:r">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-polygon">
    <element name="draw:area-polygon">
      <ref name="draw.area-polygon-attlist"/>
      <optional>
        <ref name="svg.desc"/>
      </optional>
      <optional>
        <ref name="office.events"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="draw.area-polygon"/>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:href">
        <ref name="uriReference"/>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:type">
        <choice>
          <value>simple</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="office:target-frame-name"/>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="xlink:show">
        <choice>
          <value>new</value>
          <value>replace</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="office:name"/>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <optional>
      <attribute name="draw:nohref">
        <choice>
          <value>nohref</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:x">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:y">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:width">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:height">
      <ref name="coordinate"/>
    </attribute>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:points">
      <ref name="points"/>
    </attribute>
  </define>
  <define name="draw.area-polygon-attlist" combine="interleave">
    <attribute name="svg:viewBox"/>
  </define>
</grammar>
