<?xml version="1.0" encoding="UTF-8"?>
<grammar datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes" xmlns="http://relaxng.org/ns/structure/1.0" xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns:number="http://openoffice.org/2000/datastyle" xmlns:form="http://openoffice.org/2000/form" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:dr3d="http://openoffice.org/2000/dr3d" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:office="http://openoffice.org/2000/office" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:draw="http://openoffice.org/2000/drawing" xmlns:meta="http://openoffice.org/2000/meta" xmlns:text="http://openoffice.org/2000/text" xmlns:chart="http://openoffice.org/2000/chart" xmlns:svg="http://www.w3.org/2000/svg" xmlns:style="http://openoffice.org/2000/style" xmlns:table="http://openoffice.org/2000/table" xmlns:presentation="http://openoffice.org/2001/presentation" xmlns:config="http://openoffice.org/2001/config" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:script="http://openoffice.org/2000/script">
<!--
	$Id: table.mod,v 1.42 2002/11/08 08:40:55 sab Exp $

   The Contents of this file are made available subject to the terms of
   either of the following licenses

          - GNU Lesser General Public License Version 2.1
          - Sun Industry Standards Source License Version 1.1

   Sun Microsystems Inc., October, 2000

   GNU Lesser General Public License Version 2.1
   =============================================
   Copyright 2000 by Sun Microsystems, Inc.
   901 San Antonio Road, Palo Alto, CA 94303, USA

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License version 2.1, as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA  02111-1307  USA


   Sun Industry Standards Source License Version 1.1
   =================================================
   The contents of this file are subject to the Sun Industry Standards
   Source License Version 1.1 (the "License"); You may not use this file
   except in compliance with the License. You may obtain a copy of the
   License at http://www.openoffice.org/license.html.

   Software provided under this License is provided on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
   See the License for the specific provisions governing your rights and
   obligations concerning the Software.

   The Initial Developer of the Original Code is: Sun Microsystems, Inc.

   Copyright: 2000 by Sun Microsystems, Inc.

   All Rights Reserved.

   Contributor(s): _______________________________________

-->
  <define name="table.calculation-settings">
    <element name="table:calculation-settings">
      <ref name="table.calculation-settings-attlist"/>
      <optional>
        <ref name="table.null-date"/>
      </optional>
      <optional>
        <ref name="table.iteration"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.calculation-settings"/>
  </define>
  <define name="table.calculation-settings-attlist" combine="interleave">
    <optional>
      <attribute name="table:case-sensitive" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:precision-as-shown" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:search-criteria-must-apply-to-whole-cell" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:automatic-find-labels" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:use-regular-expressions" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:null-year" a:defaultValue="1930">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="table.null-date">
    <element name="table:null-date">
      <ref name="table.null-date-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.null-date"/>
  </define>
  <define name="table.null-date-attlist" combine="interleave">
    <optional>
      <attribute name="table:value-type" a:defaultValue="date">
        <value>date</value>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:date-value" a:defaultValue="1899-12-30">
        <ref name="date"/>
      </attribute>
    </optional>
  </define>
  <define name="table.iteration">
    <element name="table:iteration">
      <ref name="table.iteration-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.iteration"/>
  </define>
  <define name="table.iteration-attlist" combine="interleave">
    <optional>
      <attribute name="table:status" a:defaultValue="disable">
        <choice>
          <value>enable</value>
          <value>disable</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:steps" a:defaultValue="100">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:maximum-difference" a:defaultValue="0.001">
        <ref name="float"/>
      </attribute>
    </optional>
  </define>
  <define name="table.tracked-changes">
    <element name="table:tracked-changes">
      <ref name="table.tracked-changes-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="table.cell-content-change"/>
          <ref name="table.insertion"/>
          <ref name="table.deletion"/>
          <ref name="table.movement"/>
          <ref name="table.rejection"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.tracked-changes"/>
  </define>
  <define name="table.tracked-changes-attlist" combine="interleave">
    <optional>
      <attribute name="table:track-changes" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:protected" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:protection-key"/>
    </optional>
  </define>
  <define name="table.dependences">
    <element name="table:dependences">
      <ref name="table.dependences-attlist"/>
      <oneOrMore>
        <ref name="table.dependence"/>
      </oneOrMore>
    </element>
  </define>
  <define name="table.dependences-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.dependences"/>
  </define>
  <define name="table.dependence">
    <element name="table:dependence">
      <ref name="table.dependence-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.dependence"/>
  </define>
  <define name="table.dependence-attlist" combine="interleave">
    <attribute name="table:id"/>
  </define>
  <define name="table.deletions">
    <element name="table:deletions">
      <ref name="table.deletions-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.cell-content-deletion"/>
          <ref name="table.change-deletion"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.deletions-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.deletions"/>
  </define>
  <define name="table.cell-content-deletion">
    <element name="table:cell-content-deletion">
      <ref name="table.cell-content-deletion-attlist"/>
      <optional>
        <ref name="table.cell-address"/>
      </optional>
      <optional>
        <ref name="table.change-track-table-cell"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.cell-content-deletion"/>
  </define>
  <define name="table.cell-content-deletion-attlist" combine="interleave">
    <optional>
      <attribute name="table:id"/>
    </optional>
  </define>
  <define name="table.change-deletion">
    <element name="table:change-deletion">
      <ref name="table.change-deletion-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.change-deletion"/>
  </define>
  <define name="table.change-deletion-attlist" combine="interleave">
    <optional>
      <attribute name="table:id"/>
    </optional>
  </define>
  <define name="table.insertion">
    <element name="table:insertion">
      <ref name="table.insertion-attlist"/>
      <ref name="office.change-info"/>
      <optional>
        <ref name="table.dependences"/>
      </optional>
      <optional>
        <ref name="table.deletions"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.insertion"/>
  </define>
  <define name="table.insertion-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:acceptance-state" a:defaultValue="pending">
        <choice>
          <value>accepted</value>
          <value>rejected</value>
          <value>pending</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:rejecting-change-id">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <attribute name="table:type">
      <choice>
        <value>row</value>
        <value>column</value>
        <value>table</value>
      </choice>
    </attribute>
    <attribute name="table:position">
      <ref name="integer"/>
    </attribute>
    <optional>
      <attribute name="table:count" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:table">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.deletion">
    <element name="table:deletion">
      <ref name="table.deletion-attlist"/>
      <ref name="office.change-info"/>
      <optional>
        <ref name="table.dependences"/>
      </optional>
      <optional>
        <ref name="table.deletions"/>
      </optional>
      <optional>
        <ref name="table.cut-offs"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.deletion"/>
  </define>
  <define name="table.deletion-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:acceptance-state" a:defaultValue="pending">
        <choice>
          <value>accepted</value>
          <value>rejected</value>
          <value>pending</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:rejecting-change-id">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <attribute name="table:type">
      <choice>
        <value>row</value>
        <value>column</value>
        <value>table</value>
      </choice>
    </attribute>
    <attribute name="table:position">
      <ref name="integer"/>
    </attribute>
    <optional>
      <attribute name="table:count" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:table">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:multi-deletion-spanned">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.cut-offs">
    <element name="table:cut-offs">
      <ref name="table.cut-offs-attlist"/>
      <choice>
        <oneOrMore>
          <ref name="table.movement-cut-off"/>
        </oneOrMore>
        <group>
          <ref name="table.insertion-cut-off"/>
          <zeroOrMore>
            <ref name="table.movement-cut-off"/>
          </zeroOrMore>
        </group>
      </choice>
    </element>
  </define>
  <define name="table.cut-offs-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.cut-offs"/>
  </define>
  <define name="table.insertion-cut-off">
    <element name="table:insertion-cut-off">
      <ref name="table.insertion-cut-off-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.insertion-cut-off"/>
  </define>
  <define name="table.insertion-cut-off-attlist" combine="interleave">
    <attribute name="table:id"/>
    <attribute name="table:position">
      <ref name="integer"/>
    </attribute>
  </define>
  <define name="table.movement-cut-off">
    <element name="table:movement-cut-off">
      <ref name="table.movement-cut-off-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.movement-cut-off"/>
  </define>
  <define name="table.movement-cut-off-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:start-position">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-position">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:position">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.movement">
    <element name="table:movement">
      <ref name="table.movement-attlist"/>
      <ref name="table.source-range-address"/>
      <ref name="table.target-range-address"/>
      <ref name="office.change-info"/>
      <optional>
        <ref name="table.dependences"/>
      </optional>
      <optional>
        <ref name="table.deletions"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.movement"/>
  </define>
  <define name="table.movement-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:acceptance-state" a:defaultValue="pending">
        <choice>
          <value>accepted</value>
          <value>rejected</value>
          <value>pending</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:rejecting-change-id">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="table.target-range-address">
    <element name="table:target-range-address">
      <ref name="table.target-range-address-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.target-range-address"/>
  </define>
  <define name="table.target-range-address-attlist" combine="interleave">
    <optional>
      <attribute name="table:column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:table">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-table">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-table">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.source-range-address">
    <element name="table:source-range-address">
      <ref name="table.source-range-address-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.source-range-address"/>
  </define>
  <define name="table.source-range-address-attlist" combine="interleave">
    <optional>
      <attribute name="table:column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:table">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:start-table">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:end-table">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.change-track-table-cell">
    <element name="table:change-track-table-cell">
      <ref name="table.change-track-table-cell-attlist"/>
      <zeroOrMore>
        <ref name="text.p"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.change-track-table-cell"/>
  </define>
  <define name="table.change-track-table-cell-attlist" combine="interleave">
    <optional>
      <attribute name="table:cell-address">
        <ref name="cell-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:matrix-covered" a:defaultValue="false">
        <choice>
          <value>true</value>
          <value>false</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:formula">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-rows-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-columns-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value-type" a:defaultValue="string">
        <ref name="valueType"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value">
        <ref name="float"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:string-value">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="table.cell-content-change">
    <element name="table:cell-content-change">
      <ref name="table.cell-content-change-attlist"/>
      <ref name="table.cell-address"/>
      <ref name="office.change-info"/>
      <optional>
        <ref name="table.dependences"/>
      </optional>
      <optional>
        <ref name="table.deletions"/>
      </optional>
      <ref name="table.previous"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.cell-content-change"/>
  </define>
  <define name="table.cell-content-change-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:acceptance-state" a:defaultValue="pending">
        <choice>
          <value>accepted</value>
          <value>rejected</value>
          <value>pending</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:rejecting-change-id">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="table.cell-address">
    <element name="table:cell-address">
      <ref name="table.cell-address-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.cell-address"/>
  </define>
  <define name="table.cell-address-attlist" combine="interleave">
    <optional>
      <attribute name="table:column">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:row">
        <ref name="integer"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:table">
        <ref name="integer"/>
      </attribute>
    </optional>
  </define>
  <define name="table.previous">
    <element name="table:previous">
      <ref name="table.previous-attlist"/>
      <ref name="table.change-track-table-cell"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.previous"/>
  </define>
  <define name="table.previous-attlist" combine="interleave">
    <optional>
      <attribute name="table:id"/>
    </optional>
  </define>
  <define name="table.rejection">
    <element name="table:rejection">
      <ref name="table.rejection-attlist"/>
      <ref name="office.change-info"/>
      <optional>
        <ref name="table.dependences"/>
      </optional>
      <optional>
        <ref name="table.deletions"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.rejection"/>
  </define>
  <define name="table.rejection-attlist" combine="interleave">
    <attribute name="table:id"/>
    <optional>
      <attribute name="table:acceptance-state" a:defaultValue="pending">
        <choice>
          <value>accepted</value>
          <value>rejected</value>
          <value>pending</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:rejecting-change-id">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="table-columns">
    <choice>
      <ref name="table.table-columns"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-column"/>
          <ref name="table.table-column-group"/>
        </choice>
      </oneOrMore>
    </choice>
  </define>
  <define name="table-header-columns">
    <ref name="table.table-header-columns"/>
  </define>
  <define name="table-rows">
    <choice>
      <ref name="table.table-rows"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-row"/>
          <ref name="table.table-row-group"/>
        </choice>
      </oneOrMore>
    </choice>
  </define>
  <define name="table-header-rows">
    <ref name="table.table-header-rows"/>
  </define>
  <define name="table-column-groups">
    <choice>
      <group>
        <ref name="table-columns"/>
        <optional>
          <ref name="table-header-columns"/>
          <optional>
            <ref name="table-columns"/>
          </optional>
        </optional>
      </group>
      <group>
        <ref name="table-header-columns"/>
        <optional>
          <ref name="table-columns"/>
        </optional>
      </group>
    </choice>
  </define>
  <define name="table-row-groups">
    <choice>
      <group>
        <ref name="table-rows"/>
        <optional>
          <ref name="table-header-rows"/>
          <optional>
            <ref name="table-rows"/>
          </optional>
        </optional>
      </group>
      <group>
        <ref name="table-header-rows"/>
        <optional>
          <ref name="table-rows"/>
        </optional>
      </group>
    </choice>
  </define>
  <define name="table.table">
    <element name="table:table">
      <ref name="table.table-attlist"/>
      <optional>
        <ref name="table.table-source"/>
      </optional>
      <optional>
        <ref name="table.scenario"/>
      </optional>
      <optional>
        <ref name="office.forms"/>
      </optional>
      <optional>
        <ref name="table.shapes"/>
      </optional>
      <ref name="table-column-groups"/>
      <ref name="table-row-groups"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table"/>
  </define>
  <define name="table.table-attlist" combine="interleave">
    <optional>
      <attribute name="table:name">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:protected" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:protection-key"/>
    </optional>
    <optional>
      <attribute name="table:print-ranges">
        <ref name="cell-range-address-list"/>
      </attribute>
    </optional>
  </define>
  <define name="table.table-source">
    <element name="table:table-source">
      <ref name="table.table-source-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-source"/>
  </define>
  <define name="table.table-source-attlist" combine="interleave">
    <optional>
      <attribute name="table:mode" a:defaultValue="copy-all">
        <choice>
          <value>copy-all</value>
          <value>copy-results-only</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
    <optional>
      <attribute name="xlink:actuate" a:defaultValue="onRequest">
        <choice>
          <value>onRequest</value>
        </choice>
      </attribute>
    </optional>
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
    <optional>
      <attribute name="table:filter-name"/>
    </optional>
    <optional>
      <attribute name="table:table-name"/>
    </optional>
    <optional>
      <attribute name="table:filter-options"/>
    </optional>
    <optional>
      <attribute name="table:refresh-delay">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="table.scenario">
    <element name="table:scenario">
      <ref name="table.scenario-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.scenario"/>
  </define>
  <define name="table.scenario-attlist" combine="interleave">
    <optional>
      <attribute name="table:display-border" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:border-color">
        <ref name="color"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:copy-back" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:copy-styles" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:copy-formulas" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <attribute name="table:is-active">
      <ref name="boolean"/>
    </attribute>
    <attribute name="table:scenario-ranges">
      <ref name="cell-range-address-list"/>
    </attribute>
    <optional>
      <attribute name="table:comment"/>
    </optional>
  </define>
  <define name="table.shapes">
    <element name="table:shapes">
      <ref name="table.shapes-attlist"/>
      <ref name="shapes"/>
    </element>
  </define>
  <define name="table.shapes-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.shapes"/>
  </define>
  <define name="table.table-column-group">
    <element name="table:table-column-group">
      <ref name="table.table-column-group-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-header-columns"/>
          <ref name="table.table-column"/>
          <ref name="table.table-column-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-column-group"/>
  </define>
  <define name="table.table-column-group-attlist" combine="interleave">
    <optional>
      <attribute name="table:display" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.table-header-columns">
    <element name="table:table-header-columns">
      <ref name="table.table-header-columns-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-column"/>
          <ref name="table.table-column-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.table-header-columns-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-header-columns"/>
  </define>
  <define name="table.table-columns">
    <element name="table:table-columns">
      <ref name="table.table-columns-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-column"/>
          <ref name="table.table-column-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.table-columns-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-columns"/>
  </define>
  <define name="table.table-column">
    <element name="table:table-column">
      <ref name="table.table-column-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-column"/>
  </define>
  <define name="table.table-column-attlist" combine="interleave">
    <optional>
      <attribute name="table:number-columns-repeated" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:visibility" a:defaultValue="visible">
        <choice>
          <value>visible</value>
          <value>collapse</value>
          <value>filter</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:default-cell-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="table.table-row-group">
    <element name="table:table-row-group">
      <ref name="table.table-row-group-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-header-rows"/>
          <ref name="table.table-row"/>
          <ref name="table.table-row-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-row-group"/>
  </define>
  <define name="table.table-row-group-attlist" combine="interleave">
    <optional>
      <attribute name="table:display" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.table-header-rows">
    <element name="table:table-header-rows">
      <ref name="table.table-header-rows-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-row"/>
          <ref name="table.table-row-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.table-header-rows-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-header-rows"/>
  </define>
  <define name="table.table-rows">
    <element name="table:table-rows">
      <ref name="table.table-rows-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.table-row"/>
          <ref name="table.table-row-group"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.table-rows-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-rows"/>
  </define>
  <define name="table-cells">
    <oneOrMore>
      <choice>
        <ref name="table.table-cell"/>
        <ref name="table.covered-table-cell"/>
      </choice>
    </oneOrMore>
  </define>
  <define name="table.table-row">
    <element name="table:table-row">
      <ref name="table.table-row-attlist"/>
      <ref name="table-cells"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-row"/>
  </define>
  <define name="table.table-row-attlist" combine="interleave">
    <optional>
      <attribute name="table:number-rows-repeated" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:visibility" a:defaultValue="visible">
        <choice>
          <value>visible</value>
          <value>collapse</value>
          <value>filter</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:default-cell-style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
  </define>
  <define name="text-wo-table">
    <zeroOrMore>
      <choice>
        <ref name="text.h"/>
        <ref name="text.p"/>
        <ref name="text.ordered-list"/>
        <ref name="text.unordered-list"/>
        <ref name="shapes"/>
      </choice>
    </zeroOrMore>
  </define>
  <define name="cell-content">
    <optional>
      <ref name="table.cell-range-source"/>
    </optional>
    <optional>
      <ref name="office.annotation"/>
    </optional>
    <optional>
      <ref name="table.detective"/>
    </optional>
    <choice>
      <ref name="table.sub-table"/>
      <ref name="text-wo-table"/>
    </choice>
  </define>
  <define name="table.table-cell">
    <element name="table:table-cell">
      <ref name="table.table-cell-attlist"/>
      <ref name="cell-content"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.table-cell"/>
  </define>
  <define name="table.covered-table-cell">
    <element name="table:covered-table-cell">
      <ref name="table.covered-table-cell-attlist"/>
      <ref name="cell-content"/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.covered-table-cell"/>
  </define>
  <define name="table.table-cell-attlist" combine="interleave">
    <optional>
      <attribute name="table:number-columns-repeated" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-rows-spanned" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-columns-spanned" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:validation-name"/>
    </optional>
    <optional>
      <attribute name="table:formula">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-rows-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-columns-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value-type" a:defaultValue="string">
        <ref name="valueType"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value">
        <ref name="float"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:boolean-value">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:string-value">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:currency">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
  <define name="table.covered-table-cell-attlist" combine="interleave">
    <optional>
      <attribute name="table:number-columns-repeated" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:style-name">
        <ref name="styleName"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:validation-name"/>
    </optional>
    <optional>
      <attribute name="table:formula">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-rows-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:number-matrix-columns-spanned">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value-type" a:defaultValue="string">
        <ref name="valueType"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:value">
        <ref name="float"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:date-value">
        <ref name="date"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:time-value">
        <ref name="timeInstance"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:boolean-value">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:string-value">
        <ref name="string"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:currency">
        <ref name="string"/>
      </attribute>
    </optional>
  </define>
<!-- cell protection in writer: cell attribute; calc uses format -->
  <define name="table.table-cell-attlist" combine="interleave">
    <optional>
      <attribute name="table:protected" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.cell-range-source">
    <element name="table:cell-range-source">
      <ref name="table.cell-range-source-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.cell-range-source"/>
  </define>
  <define name="table.cell-range-source-attlist" combine="interleave">
    <attribute name="table:name">
      <ref name="string"/>
    </attribute>
    <optional>
      <attribute name="xlink:type" a:defaultValue="simple">
        <value>simple</value>
      </attribute>
    </optional>
    <optional>
      <attribute name="xlink:actuate" a:defaultValue="onRequest">
        <value>onRequest</value>
      </attribute>
    </optional>
    <attribute name="xlink:href">
      <ref name="uriReference"/>
    </attribute>
    <attribute name="table:filter-name">
      <ref name="string"/>
    </attribute>
    <optional>
      <attribute name="table:filter-options">
        <ref name="string"/>
      </attribute>
    </optional>
    <attribute name="table:last-column-spanned">
      <ref name="positiveInteger"/>
    </attribute>
    <attribute name="table:last-row-spanned">
      <ref name="positiveInteger"/>
    </attribute>
    <optional>
      <attribute name="table:refresh-delay">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="table.detective">
    <element name="table:detective">
      <ref name="table.detective-attlist"/>
      <zeroOrMore>
        <ref name="table.highlighted-range"/>
      </zeroOrMore>
      <zeroOrMore>
        <ref name="table.operation"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.detective-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.detective"/>
  </define>
  <define name="table.highlighted-range">
    <element name="table:highlighted-range">
      <ref name="table.highlighted-range-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.highlighted-range"/>
  </define>
  <define name="table.highlighted-range-attlist" combine="interleave">
    <optional>
      <attribute name="table:cell-range-address">
        <ref name="cell-range-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:direction">
        <choice>
          <value>from-another-table</value>
          <value>to-another-table</value>
          <value>from-same-table</value>
          <value>to-same-table</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:contains-error">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:marked-invalid">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.operation">
    <element name="table:operation">
      <ref name="table.operation-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.operation"/>
  </define>
  <define name="table.operation-attlist" combine="interleave">
    <attribute name="table:name">
      <choice>
        <value>trace-dependents</value>
        <value>remove-dependents</value>
        <value>trace-precedents</value>
        <value>remove-precedents</value>
        <value>trace-errors</value>
      </choice>
    </attribute>
    <attribute name="table:index">
      <ref name="nonNegativeInteger"/>
    </attribute>
  </define>
  <define name="table.content-validations">
    <element name="table:content-validations">
      <ref name="table.content-validations-attlist"/>
      <oneOrMore>
        <ref name="table.content-validation"/>
      </oneOrMore>
    </element>
  </define>
  <define name="table.content-validations-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.content-validations"/>
  </define>
  <define name="table.content-validation">
    <element name="table:content-validation">
      <ref name="table.content-validation-attlist"/>
      <optional>
        <ref name="table.help-message"/>
      </optional>
      <optional>
        <choice>
          <ref name="table.error-message"/>
          <group>
            <ref name="table.error-macro"/>
            <optional>
              <ref name="office.events"/>
            </optional>
          </group>
        </choice>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.content-validation"/>
  </define>
  <define name="table.content-validation-attlist" combine="interleave">
    <attribute name="table:name"/>
    <optional>
      <attribute name="table:condition"/>
    </optional>
    <optional>
      <attribute name="table:base-cell-address">
        <ref name="cell-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:allow-empty-cell">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.help-message">
    <element name="table:help-message">
      <ref name="table.help-message-attlist"/>
      <zeroOrMore>
        <ref name="text.p"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.help-message"/>
  </define>
  <define name="table.help-message-attlist" combine="interleave">
    <optional>
      <attribute name="table:title"/>
    </optional>
    <optional>
      <attribute name="table:display">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.error-message">
    <element name="table:error-message">
      <ref name="table.error-message-attlist"/>
      <zeroOrMore>
        <ref name="text.p"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.error-message"/>
  </define>
  <define name="table.error-message-attlist" combine="interleave">
    <optional>
      <attribute name="table:title"/>
    </optional>
    <optional>
      <attribute name="table:message-type">
        <choice>
          <value>stop</value>
          <value>warning</value>
          <value>information</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:display">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.error-macro">
    <element name="table:error-macro">
      <ref name="table.error-macro-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.error-macro"/>
  </define>
  <define name="table.error-macro-attlist" combine="interleave">
    <optional>
      <attribute name="table:name"/>
    </optional>
    <optional>
      <attribute name="table:execute">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.sub-table">
    <element name="table:sub-table">
      <ref name="table.sub-table-attlist"/>
      <ref name="table-column-groups"/>
      <ref name="table-row-groups"/>
    </element>
  </define>
  <define name="table.sub-table-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.sub-table"/>
  </define>
  <define name="table.label-ranges">
    <element name="table:label-ranges">
      <ref name="table.label-ranges-attlist"/>
      <zeroOrMore>
        <ref name="table.label-range"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.label-ranges-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.label-ranges"/>
  </define>
  <define name="table.label-range">
    <element name="table:label-range">
      <ref name="table.label-range-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.label-range"/>
  </define>
  <define name="table.label-range-attlist" combine="interleave">
    <attribute name="table:label-cell-range-address">
      <ref name="cell-range-address"/>
    </attribute>
    <attribute name="table:data-cell-range-address">
      <ref name="cell-range-address"/>
    </attribute>
    <attribute name="table:orientation">
      <choice>
        <value>column</value>
        <value>row</value>
      </choice>
    </attribute>
  </define>
  <define name="table.named-expressions">
    <element name="table:named-expressions">
      <ref name="table.named-expressions-attlist"/>
      <zeroOrMore>
        <choice>
          <ref name="table.named-range"/>
          <ref name="table.named-expression"/>
        </choice>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.named-expressions-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.named-expressions"/>
  </define>
  <define name="table.named-range">
    <element name="table:named-range">
      <ref name="table.named-range-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.named-range"/>
  </define>
  <define name="table.named-range-attlist" combine="interleave">
    <attribute name="table:name"/>
    <attribute name="table:cell-range-address">
      <ref name="cell-range-address"/>
    </attribute>
    <optional>
      <attribute name="table:base-cell-address">
        <ref name="cell-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:range-usable-as" a:defaultValue="none"/>
    </optional>
  </define>
  <define name="table.named-expression">
    <element name="table:named-expression">
      <ref name="table.named-expression-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.named-expression"/>
  </define>
  <define name="table.named-expression-attlist" combine="interleave">
    <attribute name="table:name"/>
    <attribute name="table:expression"/>
    <optional>
      <attribute name="table:base-cell-address">
        <ref name="cell-address"/>
      </attribute>
    </optional>
  </define>
  <define name="table.filter">
    <element name="table:filter">
      <ref name="table.filter-attlist"/>
      <choice>
        <ref name="table.filter-condition"/>
        <ref name="table.filter-and"/>
        <ref name="table.filter-or"/>
      </choice>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.filter"/>
  </define>
  <define name="table.filter-attlist" combine="interleave">
    <optional>
      <attribute name="table:target-range-address">
        <ref name="cell-range-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:condition-source-range-address">
        <ref name="cell-range-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:condition-source" a:defaultValue="self">
        <choice>
          <value>self</value>
          <value>cell-range</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:display-duplicates" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.filter-and">
    <element name="table:filter-and">
      <ref name="table.filter-and-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.filter-or"/>
          <ref name="table.filter-condition"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.filter-and-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.filter-and"/>
  </define>
  <define name="table.filter-or">
    <element name="table:filter-or">
      <ref name="table.filter-or-attlist"/>
      <oneOrMore>
        <choice>
          <ref name="table.filter-and"/>
          <ref name="table.filter-condition"/>
        </choice>
      </oneOrMore>
    </element>
  </define>
  <define name="table.filter-or-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.filter-or"/>
  </define>
  <define name="table.filter-condition">
    <element name="table:filter-condition">
      <ref name="table.filter-condition-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.filter-condition"/>
  </define>
  <define name="table.filter-condition-attlist" combine="interleave">
    <attribute name="table:field-number">
      <ref name="nonNegativeInteger"/>
    </attribute>
    <optional>
      <attribute name="table:case-sensitive" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:data-type" a:defaultValue="text">
        <choice>
          <value>text</value>
          <value>number</value>
        </choice>
      </attribute>
    </optional>
    <attribute name="table:value"/>
    <attribute name="table:operator"/>
  </define>
  <define name="table.database-ranges">
    <element name="table:database-ranges">
      <ref name="table.database-ranges-attlist"/>
      <zeroOrMore>
        <ref name="table.database-range"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.database-ranges-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.database-ranges"/>
  </define>
  <define name="table.database-range">
    <element name="table:database-range">
      <ref name="table.database-range-attlist"/>
      <optional>
        <choice>
          <ref name="table.database-source-sql"/>
          <ref name="table.database-source-table"/>
          <ref name="table.database-source-query"/>
        </choice>
      </optional>
      <optional>
        <ref name="table.filter"/>
      </optional>
      <optional>
        <ref name="table.sort"/>
      </optional>
      <optional>
        <ref name="table.subtotal-rules"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.database-range"/>
  </define>
  <define name="table.database-range-attlist" combine="interleave">
    <optional>
      <attribute name="table:name"/>
    </optional>
    <optional>
      <attribute name="table:is-selection" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:on-update-keep-styles" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:on-update-keep-size" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:has-persistant-data" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:orientation" a:defaultValue="row">
        <choice>
          <value>row</value>
          <value>column</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:contains-header" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:display-filter-buttons" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <attribute name="table:target-range-address">
      <ref name="cell-range-address"/>
    </attribute>
    <optional>
      <attribute name="table:refresh-delay">
        <ref name="timeDuration"/>
      </attribute>
    </optional>
  </define>
  <define name="table.database-source-sql">
    <element name="table:database-source-sql">
      <ref name="table.database-source-sql-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.database-source-sql"/>
  </define>
  <define name="table.database-source-sql-attlist" combine="interleave">
    <attribute name="table:database-name"/>
    <attribute name="table:sql-statement"/>
    <optional>
      <attribute name="table:parse-sql-statements" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.database-source-table">
    <element name="table:database-source-table">
      <ref name="table.database-source-table-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.database-source-table"/>
  </define>
  <define name="table.database-source-table-attlist" combine="interleave">
    <attribute name="table:database-name"/>
    <attribute name="table:table-name"/>
  </define>
  <define name="table.database-source-query">
    <element name="table:database-source-query">
      <ref name="table.database-source-query-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.database-source-query"/>
  </define>
  <define name="table.database-source-query-attlist" combine="interleave">
    <attribute name="table:database-name"/>
    <attribute name="table:query-name"/>
  </define>
  <define name="table.sort">
    <element name="table:sort">
      <ref name="table.sort-attlist"/>
      <oneOrMore>
        <ref name="table.sort-by"/>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.sort"/>
  </define>
  <define name="table.sort-attlist" combine="interleave">
    <optional>
      <attribute name="table:bind-styles-to-content" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:target-range-address">
        <ref name="cell-range-address"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:case-sensitive" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:language"/>
    </optional>
    <optional>
      <attribute name="table:country"/>
    </optional>
    <optional>
      <attribute name="table:algorithm"/>
    </optional>
  </define>
  <define name="table.sort-by">
    <element name="table:sort-by">
      <ref name="table.sort-by-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.sort-by"/>
  </define>
  <define name="table.sort-by-attlist" combine="interleave">
    <attribute name="table:field-number">
      <ref name="nonNegativeInteger"/>
    </attribute>
    <optional>
      <attribute name="table:data-type" a:defaultValue="automatic"/>
    </optional>
    <optional>
      <attribute name="table:order" a:defaultValue="ascending">
        <choice>
          <value>ascending</value>
          <value>descending</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="table.subtotal-rules">
    <element name="table:subtotal-rules">
      <ref name="table.subtotal-rules-attlist"/>
      <optional>
        <choice>
          <optional>
            <ref name="table.sort-groups"/>
          </optional>
          <zeroOrMore>
            <ref name="table.subtotal-rule"/>
          </zeroOrMore>
        </choice>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.subtotal-rules"/>
  </define>
  <define name="table.subtotal-rules-attlist" combine="interleave">
    <optional>
      <attribute name="table:bind-styles-to-content" a:defaultValue="true">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:case-sensitive" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:page-breaks-on-group-change" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.sort-groups">
    <element name="table:sort-groups">
      <ref name="table.sort-groups-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.sort-groups"/>
  </define>
  <define name="table.sort-groups-attlist" combine="interleave">
    <optional>
      <attribute name="table:data-type" a:defaultValue="automatic"/>
    </optional>
    <optional>
      <attribute name="table:order" a:defaultValue="ascending">
        <choice>
          <value>ascending</value>
          <value>descending</value>
        </choice>
      </attribute>
    </optional>
  </define>
  <define name="table.subtotal-rule">
    <element name="table:subtotal-rule">
      <ref name="table.subtotal-rule-attlist"/>
      <zeroOrMore>
        <ref name="table.subtotal-field"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.subtotal-rule"/>
  </define>
  <define name="table.subtotal-rule-attlist" combine="interleave">
    <attribute name="table:group-by-field-number">
      <ref name="nonNegativeInteger"/>
    </attribute>
  </define>
  <define name="table.subtotal-field">
    <element name="table:subtotal-field">
      <ref name="table.subtotal-field-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.subtotal-field"/>
  </define>
  <define name="table.subtotal-field-attlist" combine="interleave">
    <attribute name="table:field-number">
      <ref name="nonNegativeInteger"/>
    </attribute>
    <attribute name="table:function"/>
  </define>
  <define name="table.data-pilot-tables">
    <element name="table:data-pilot-tables">
      <ref name="table.data-pilot-tables-attlist"/>
      <zeroOrMore>
        <ref name="table.data-pilot-table"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.data-pilot-tables-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-tables"/>
  </define>
  <define name="table.data-pilot-table">
    <element name="table:data-pilot-table">
      <ref name="table.data-pilot-table-attlist"/>
      <optional>
        <choice>
          <ref name="table.database-source-sql"/>
          <ref name="table.database-source-table"/>
          <ref name="table.database-source-query"/>
          <ref name="table.source-service"/>
          <ref name="table.source-cell-range"/>
        </choice>
      </optional>
      <oneOrMore>
        <ref name="table.data-pilot-field"/>
      </oneOrMore>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-table"/>
  </define>
  <define name="table.data-pilot-table-attlist" combine="interleave">
    <attribute name="table:name"/>
    <optional>
      <attribute name="table:application-data"/>
    </optional>
    <optional>
      <attribute name="table:grand-total" a:defaultValue="both">
        <choice>
          <value>none</value>
          <value>row</value>
          <value>column</value>
          <value>both</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:ignore-empty-rows" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:identify-categories" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <attribute name="table:target-range-address">
      <ref name="cell-range-address"/>
    </attribute>
    <attribute name="table:buttons">
      <ref name="cell-range-address-list"/>
    </attribute>
  </define>
  <define name="table.source-service">
    <element name="table:source-service">
      <ref name="table.source-service-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.source-service"/>
  </define>
  <define name="table.source-service-attlist" combine="interleave">
    <attribute name="table:name"/>
    <attribute name="table:source-name"/>
    <attribute name="table:object-name"/>
    <optional>
      <attribute name="table:username"/>
    </optional>
    <optional>
      <attribute name="table:password"/>
    </optional>
  </define>
  <define name="table.source-cell-range">
    <element name="table:source-cell-range">
      <ref name="table.source-cell-range-attlist"/>
      <optional>
        <ref name="table.filter"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.source-cell-range"/>
  </define>
  <define name="table.source-cell-range-attlist" combine="interleave">
    <attribute name="table:cell-range-address">
      <ref name="cell-range-address"/>
    </attribute>
  </define>
  <define name="table.data-pilot-field">
    <element name="table:data-pilot-field">
      <ref name="table.data-pilot-field-attlist"/>
      <optional>
        <ref name="table.data-pilot-level"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-field"/>
  </define>
  <define name="table.data-pilot-field-attlist" combine="interleave">
    <attribute name="table:source-field-name"/>
    <optional>
      <attribute name="table:is-data-layout-field" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <attribute name="table:function"/>
    <attribute name="table:orientation">
      <choice>
        <value>row</value>
        <value>column</value>
        <value>data</value>
        <value>page</value>
        <value>hidden</value>
      </choice>
    </attribute>
    <optional>
      <attribute name="table:used-hierarchy" a:defaultValue="1">
        <ref name="positiveInteger"/>
      </attribute>
    </optional>
  </define>
  <define name="table.data-pilot-level">
    <element name="table:data-pilot-level">
      <ref name="table.data-pilot-level-attlist"/>
      <optional>
        <ref name="table.data-pilot-subtotals"/>
      </optional>
      <optional>
        <ref name="table.data-pilot-members"/>
      </optional>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-level"/>
  </define>
  <define name="table.data-pilot-level-attlist" combine="interleave">
    <optional>
      <attribute name="table:display-empty">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.data-pilot-subtotals">
    <element name="table:data-pilot-subtotals">
      <ref name="table.data-pilot-subtotals-attlist"/>
      <zeroOrMore>
        <ref name="table.data-pilot-subtotal"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.data-pilot-subtotals-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-subtotals"/>
  </define>
  <define name="table.data-pilot-subtotal">
    <element name="table:data-pilot-subtotal">
      <ref name="table.data-pilot-subtotal-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-subtotal"/>
  </define>
  <define name="table.data-pilot-subtotal-attlist" combine="interleave">
    <attribute name="table:function"/>
  </define>
  <define name="table.data-pilot-members">
    <element name="table:data-pilot-members">
      <ref name="table.data-pilot-members-attlist"/>
      <zeroOrMore>
        <ref name="table.data-pilot-member"/>
      </zeroOrMore>
    </element>
  </define>
  <define name="table.data-pilot-members-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-members"/>
  </define>
  <define name="table.data-pilot-member">
    <element name="table:data-pilot-member">
      <ref name="table.data-pilot-member-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.data-pilot-member"/>
  </define>
  <define name="table.data-pilot-member-attlist" combine="interleave">
    <attribute name="table:name"/>
    <optional>
      <attribute name="table:display">
        <ref name="boolean"/>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:display-details">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.consolidation">
    <element name="table:consolidation">
      <ref name="table.consolidation-attlist"/>
      <empty/>
    </element>
  </define>
  <define name="any" combine="choice">
    <ref name="table.consolidation"/>
  </define>
  <define name="table.consolidation-attlist" combine="interleave">
    <attribute name="table:function"/>
    <attribute name="table:source-cell-range-addresses">
      <ref name="cell-range-address-list"/>
    </attribute>
    <attribute name="table:target-cell-address">
      <ref name="cell-address"/>
    </attribute>
    <optional>
      <attribute name="table:use-label" a:defaultValue="none">
        <choice>
          <value>none</value>
          <value>column</value>
          <value>row</value>
          <value>both</value>
        </choice>
      </attribute>
    </optional>
    <optional>
      <attribute name="table:link-to-source-data" a:defaultValue="false">
        <ref name="boolean"/>
      </attribute>
    </optional>
  </define>
  <define name="table.dde-links">
    <element name="table:dde-links">
      <ref name="table.dde-links-attlist"/>
      <oneOrMore>
        <ref name="table.dde-link"/>
      </oneOrMore>
    </element>
  </define>
  <define name="table.dde-links-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.dde-links"/>
  </define>
  <define name="table.dde-link">
    <element name="table:dde-link">
      <ref name="table.dde-link-attlist"/>
      <ref name="office.dde-source"/>
      <ref name="table.table"/>
    </element>
  </define>
  <define name="table.dde-link-attlist" combine="interleave">
    <empty/>
  </define>
  <define name="any" combine="choice">
    <ref name="table.dde-link"/>
  </define>
</grammar>
